Unit SF72R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTSF16_p;

procedure SF72R(X :Real; RLAM :Real; A :Real; var FX :Real;
                var IER :Integer);

implementation

procedure SF72R(X :Real; RLAM :Real; A :Real; var FX :Real;
                var IER :Integer);
label
_10,_20,_30,_40,_50;
begin
IER  := 0;
if ( RLAM  <=  0.0 ) 
 then goto _30;
if ( X  <=  0.0 ) 
 then goto _20;
if ( X  >=  1.0 ) 
 then goto _20;
if ( X  >=  0.5 ) 
 then goto _10;
FX  := A + Ln(2.0*X)/RLAM;
goto _50;
_10:
FX  := A - Ln((1.0-X)*2.0)/RLAM;
goto _50;
_20:
IER  := 66;
goto _40;
_30:
IER  := 65;
_40:
FX  := 0.0;
UTSF16(IER,4);
_50:
end;

end.
